%define anolis_release 3

%bcond_with tests

Name:           python-setuptools-rust
Version:        1.8.1
Release:        %{anolis_release}%{dist}
Summary:        Setuptools Rust extension plugin

License:        MIT
URL:            https://github.com/PyO3/setuptools-rust
Source0:        %{pypi_source setuptools-rust}
BuildArch:      noarch
ExclusiveArch:  %{rust_arches}

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools) > 46.1
BuildRequires:  python3dist(semantic-version) >= 2.8.2
BuildRequires:  python3dist(typing-extensions) >= 3.7.4.4

BuildRequires:  python3dist(setuptools-scm) >= 3.4.3
BuildRequires:  python3dist(wheel)
BuildRequires:  rust-packaging >= 1.45

%if %{with tests}
BuildRequires:  rust-pyo3+default-devel
%endif

%description
Setuptools helpers for Rust Python extensions. Compile and distribute Python
extensions written in Rust as easily as if they were written in C.

%package -n     python3-setuptools-rust
Summary:        %{summary}

Requires:       cargo

%description -n python3-setuptools-rust
Setuptools helpers for Rust Python extensions. Compile and distribute Python
extensions written in Rust as easily as if they were written in C.

%package -n     python3-setuptools-rust-doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description -n python3-setuptools-rust-doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n setuptools-rust-%{version}
# Remove bundled egg-info
rm -rf setuptools-rust.egg-info

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
%generate_compatibility_deps

%check
PYTHONPATH=%{buildroot}%{python3_sitelib} \
    %{__python3} -c "from setuptools_rust import RustExtension, version"

%if %{with tests}
cd examples/hello-world
%cargo_prep
PYTHONPATH=%{buildroot}%{python3_sitelib} %{__python3} setup.py build
cd ../..
%endif

%files -n python3-setuptools-rust
%license LICENSE
%{python3_sitelib}/setuptools_rust/
%{python3_sitelib}/setuptools_rust-%{version}.dist-info/

%files -n python3-setuptools-rust-doc
%doc README.md CHANGELOG.md

%changelog
* Fri Nov 15 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.8.1-3
- change python3-setuptools-rust requires to cargo

* Mon Mar 25 2024 Bo Ren <rb01097748@alibaba-inc.com> - 1.8.1-2
- Rebuild with python3.11

* Mon Nov 20 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.8.1-1
- update to version 1.8.1

* Sat Apr 01 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 1.5.2-1
- Init package from upstream
